Subject: Re: [PATCH net] net: hyperv: initialize link status correctly

From: Jason Wang <[email-masked]>
Date: Mon, 27 Jan 2014 18:37:14 +0800

On 01/27/2014 06:30 PM, Ben Hutchings wrote:
> On Mon, 2014-01-27 at 18:28 +0800, Jason Wang wrote:
>> On 01/27/2014 06:22 PM, Ben Hutchings wrote:
>>> On Mon, 2014-01-27 at 17:40 +0800, Jason Wang wrote:
>>>> On 01/27/2014 04:35 PM, David Miller wrote:
>>>>> From: Jason Wang <[email-masked]>
>>>>> Date: Mon, 27 Jan 2014 15:30:54 +0800
>>>>>
>>>>>> Call netif_carrier_on() after register_device(). Otherwise it won't work since
>>>>>> the device was still in NETREG_UNINITIALIZED state.
>>>>>>
>>>>>> Fixes a68f9614614749727286f675d15f1e09d13cb54a
>>>>>> (hyperv: Fix race between probe and open calls)
>>>>>>
>>>>>> Cc: Haiyang Zhang <[email-masked]>
>>>>>> Cc: K. Y. Srinivasan <[email-masked]>
>>>>>> Reported-by: Di Nie <[email-masked]>
>>>>>> Tested-by: Di Nie <[email-masked]>
>>>>>> Signed-off-by: Jason Wang <[email-masked]>
>>>>> A device up can occur at the moment you call register_netdevice(),
>>>>> therefore that up call can see the carrier as down and fail or
>>>>> similar.  So you really cannot resolve the carrier to be on in this
>>>>> way.
>>>> True, we need a workqueue to synchronize them.
>>> Whatever for?  All you need to do is:
>>>
>>> 	rtnl_lock();
>>> 	register_netdevice();
>>> 	netif_carrier_on();
>>> 	rtnl_unlock();
>>>
>>> It would be nice if we could make the current code work with a change in
>>> the core, though.
>>>
>>> Ben.
>>>
>> Looks like the link status interrupt may happen during this (after
>> netvsc_device_add() was called by rndis_filter_device_add()) without any
>> synchronization. This may lead a wrong link status here.
> Now I'm confused - if there's a link status interrupt, why are you
> setting the carrier on initially?
>
> Ben.
>

I realize that setting carrier on initially was a bug after David's
comment. So I think we need a workqueue.